diff --git a/src/preprocessors/perf-base.c b/src/preprocessors/perf-base.c
index 8983774..e76ef1a 100644
--- a/src/preprocessors/perf-base.c
+++ b/src/preprocessors/perf-base.c
@@ -7,6 +7,9 @@
 ** Dan Roelker <droelker () sourcefire com>
 ** Marc Norton <mnorton () sourcefire com>
 **
+** SCTP bits Copyright (C) 2013
+** Joshua Kinard <kumba12345 () gmail com>
+**
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License Version 2 as
 ** published by the Free Software Foundation.  You may not use, modify or
@@ -40,6 +43,8 @@
 **              and the permonitor command has 'reset' and 'accrue' commands instead.(MAN)
 **    10.4.06 : Added UDP Session Stats (SAS)
 **    4.3.07  : Added stats for TCP sessions (SAS)
+**    8.27.11 : Added stats for SCTP sessions (JK)
+**    5.19.13 : Updated SCTP support for current code (JK)
 */
 
 #include <time.h>
@@ -180,6 +185,9 @@ int InitBaseStats(SFBASE *sfBase)
     sfBase->iNewUDPSessions = 0;
     sfBase->iDeletedUDPSessions = 0;
 
+    sfBase->iNewSCTPSessions = 0;
+    sfBase->iDeletedSCTPSessions = 0;
+
     //sfBase->iAttributeHosts = 0;
     //sfBase->iAttributeReloads = 0;
     sfBase->total_mpls_packets = 0;
@@ -189,6 +197,7 @@ int InitBaseStats(SFBASE *sfBase)
 
     sfBase->total_tcp_filtered_packets = 0;
     sfBase->total_udp_filtered_packets = 0;
+    sfBase->total_sctp_filtered_packets = 0;
 
     sfBase->frag3_mem_in_use = 0;
     sfBase->stream5_mem_in_use = 0;
@@ -358,7 +367,7 @@ void UpdateIPReassStats(SFBASE *sfBase, int len)
 }
 
 /**API to update stats for packets discarded due to
- * TCP/UDP port/service based filtering.
+ * TCP/UDP/SCTP port/service based filtering.
  *
  * @param sfBase - pointer to accumulated stats
  */
@@ -372,6 +381,9 @@ void UpdateFilteredPacketStats(SFBASE *sfBase, unsigned int proto)
         case IPPROTO_UDP:
             sfBase->total_udp_filtered_packets++;
             break;
+        case IPPROTO_SCTP:
+            sfBase->total_sctp_filtered_packets++;
+            break;
         default:
             //coding error
             ;
@@ -504,6 +516,51 @@ int RemoveUDPSession(SFBASE *sfBase)
 
 /*
 **  NAME
+**    AddSCTPSession
+**
+**  DESCRIPTION
+**    Add a session count
+**
+**  FORMAL INPUTS
+**    SFBASE * - ptr to update.
+**
+**  FORMAL OUTPUTS
+**    int - 0 is successful
+*/
+int AddSCTPSession(SFBASE *sfBase)
+{
+    sfBase->iTotalSCTPSessions++;
+    sfBase->iNewSCTPSessions++;
+
+    if(sfBase->iTotalSCTPSessions > sfBase->iMaxSCTPSessions)
+        sfBase->iMaxSCTPSessions = sfBase->iTotalSCTPSessions;
+
+    return 0;
+}
+
+/*
+**  NAME
+**    RemoveSCTPSession
+**
+**  DESCRIPTION
+**    Add a session count
+**
+**  FORMAL INPUTS
+**    SFBASE * - ptr to update.
+**
+**  FORMAL OUTPUTS
+**    int - 0 is successful
+*/
+
+int RemoveSCTPSession(SFBASE *sfBase)
+{
+    sfBase->iTotalSCTPSessions--;
+    sfBase->iDeletedSCTPSessions++;
+    return 0;
+}
+
+/*
+**  NAME
 **    ProcessBaseStats
 **
 **  DESCRIPTION
@@ -690,6 +747,17 @@ int GetEventsPerSecond(SFBASE *sfBase, SFBASE_STATS *sfBaseStats,
     sfBase->iNewUDPSessions = 0;
     sfBase->iDeletedUDPSessions = 0;
 
+    sfBaseStats->total_sctp_sessions = sfBase->iTotalSCTPSessions;
+    sfBaseStats->max_sctp_sessions = sfBase->iMaxSCTPSessions;
+    sfBaseStats->deleted_sctp_sessions_per_second =
+        (double)(sfBase->iDeletedSCTPSessions) / Systimes->realtime;
+
+    sfBaseStats->new_sctp_sessions_per_second =
+        (double)(sfBase->iNewSCTPSessions) / Systimes->realtime;
+
+    sfBase->iNewSCTPSessions = 0;
+    sfBase->iDeletedSCTPSessions = 0;
+
     sfBase->iMaxSessionsInterval = sfBase->iTotalSessions;
     sfBase->iMidStreamSessions = 0;
     sfBase->iClosedSessions = 0;
@@ -975,6 +1043,7 @@ int CalculateBasePerfStats(SFBASE *sfBase, SFBASE_STATS *sfBaseStats)
 
     sfBaseStats->total_tcp_filtered_packets = sfBase->total_tcp_filtered_packets;
     sfBaseStats->total_udp_filtered_packets = sfBase->total_udp_filtered_packets;
+    sfBaseStats->total_sctp_filtered_packets = sfBase->total_sctp_filtered_packets;
 
 #ifdef NORMALIZER
     {
@@ -1213,6 +1282,10 @@ int GetPktDropStats(SFBASE *sfBase, SFBASE_STATS *sfBaseStats)
  * max-udp-sessions
  * del-udp-sessions/sec (udp stream cache)
  * new-udp-sessions/sec (udp stream cache)
+ * sctp-sessions
+ * max-sctp-sessions
+ * del-sctp-sessions/sec (sctp stream cache)
+ * new-sctp-sessions/sec (sctp stream cache)
  * max-sessions, interval (tcp stream cache)
  * curr-tcp-sessions-initializing (tcp stream cache, of total-sessions open)
  * curr-tcp-sessions-established (tcp stream cache, of total-sessions open)
@@ -1335,6 +1408,12 @@ int LogBasePerfStats(SFBASE_STATS *sfBaseStats,  FILE * fh )
             sfBaseStats->total_udp_sessions,
             sfBaseStats->max_udp_sessions);
 
+    fprintf(fh, "%.3f,%.3f," CSVu64 CSVu64,
+            sfBaseStats->new_sctp_sessions_per_second,
+            sfBaseStats->deleted_sctp_sessions_per_second,
+            sfBaseStats->total_sctp_sessions,
+            sfBaseStats->max_sctp_sessions);
+
     fprintf(fh, CSVu64 CSVu64 CSVu64 CSVu64 "%.3f,%.3f,%.3f,%.3f,%.3f,",
             sfBaseStats->max_tcp_sessions_interval,
             sfBaseStats->curr_tcp_sessions_initializing,
@@ -1354,9 +1433,10 @@ int LogBasePerfStats(SFBASE_STATS *sfBaseStats,  FILE * fh )
             sfBaseStats->avg_bytes_per_mpls_packet,
             sfBaseStats->kpackets_per_sec_mpls.realtime);
 
-    fprintf(fh, CSVu64 CSVu64,
+    fprintf(fh, CSVu64 CSVu64 CSVu64,
             sfBaseStats->total_tcp_filtered_packets,
-            sfBaseStats->total_udp_filtered_packets);
+            sfBaseStats->total_udp_filtered_packets,
+            sfBaseStats->total_sctp_filtered_packets);
 
 #ifdef NORMALIZER
     for ( iCtr = 0; iCtr < PERF_COUNT_MAX; iCtr++ )
@@ -1584,6 +1664,7 @@ int DisplayBasePerfStatsConsole(SFBASE_STATS *sfBaseStats, int iFlags)
     LogMessage("Injected:    " STDu64 "\n", sfBaseStats->total_injected_packets);
     LogMessage("Pkts Filtered TCP:     " STDu64 "\n", sfBaseStats->total_tcp_filtered_packets);
     LogMessage("Pkts Filtered UDP:     " STDu64 "\n\n", sfBaseStats->total_udp_filtered_packets);
+    LogMessage("Pkts Filtered SCTP:    " STDu64 "\n\n", sfBaseStats->total_sctp_filtered_packets);
 
     LogMessage("Mbits/Sec:   %.3f (wire)\n",
             sfBaseStats->wire_mbits_per_sec.realtime);
@@ -1663,52 +1744,58 @@ int DisplayBasePerfStatsConsole(SFBASE_STATS *sfBaseStats, int iFlags)
     /*
     **  Shows the number of snort alerts per second.
     */
-    LogMessage("Alerts/Sec             :  %.3f\n",   sfBaseStats->alerts_per_second);
+    LogMessage("Alerts/Sec              :  %.3f\n",   sfBaseStats->alerts_per_second);
 
     /* Session estimation statistics */
-    LogMessage("Syns/Sec               :  %.3f\n", sfBaseStats->syns_per_second);
-    LogMessage("Syn-Acks/Sec           :  %.3f\n", sfBaseStats->synacks_per_second);
-    LogMessage("New Cached Sessions/Sec:  %.3f\n", sfBaseStats->new_sessions_per_second);
-    LogMessage("Midstream Sessions/Sec :  %.3f\n", sfBaseStats->tcp_sessions_midstream_per_second);
-    LogMessage("Cached Sessions Del/Sec:  %.3f\n", sfBaseStats->deleted_sessions_per_second);
-    LogMessage("Closed Sessions/Sec    :  %.3f\n", sfBaseStats->tcp_sessions_closed_per_second);
-    LogMessage("TimedOut Sessions/Sec  :  %.3f\n", sfBaseStats->tcp_sessions_timedout_per_second);
-    LogMessage("Pruned Sessions/Sec    :  %.3f\n", sfBaseStats->tcp_sessions_pruned_per_second);
-    LogMessage("Dropped Async Ssns/Sec :  %.3f\n", sfBaseStats->tcp_sessions_dropped_async_per_second);
-
-    LogMessage("Current Cached Sessions:  " STDu64 "\n", sfBaseStats->total_sessions);
-    LogMessage("Sessions Initializing  :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_initializing);
-    LogMessage("Sessions Established   :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_established);
-    LogMessage("Sessions Closing       :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_closing);
-    LogMessage("Max Cached Sessions    :  " STDu64 "\n", sfBaseStats->max_sessions);
-    LogMessage("Max Sessions (interval):  " STDu64 "\n", sfBaseStats->max_tcp_sessions_interval);
+    LogMessage("Syns/Sec                :  %.3f\n", sfBaseStats->syns_per_second);
+    LogMessage("Syn-Acks/Sec            :  %.3f\n", sfBaseStats->synacks_per_second);
+    LogMessage("New Cached Sessions/Sec :  %.3f\n", sfBaseStats->new_sessions_per_second);
+    LogMessage("Midstream Sessions/Sec  :  %.3f\n", sfBaseStats->tcp_sessions_midstream_per_second);
+    LogMessage("Cached Sessions Del/Sec :  %.3f\n", sfBaseStats->deleted_sessions_per_second);
+    LogMessage("Closed Sessions/Sec     :  %.3f\n", sfBaseStats->tcp_sessions_closed_per_second);
+    LogMessage("TimedOut Sessions/Sec   :  %.3f\n", sfBaseStats->tcp_sessions_timedout_per_second);
+    LogMessage("Pruned Sessions/Sec     :  %.3f\n", sfBaseStats->tcp_sessions_pruned_per_second);
+    LogMessage("Dropped Async Ssns/Sec  :  %.3f\n", sfBaseStats->tcp_sessions_dropped_async_per_second);
+
+    LogMessage("Current Cached Sessions :  " STDu64 "\n", sfBaseStats->total_sessions);
+    LogMessage("Sessions Initializing   :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_initializing);
+    LogMessage("Sessions Established    :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_established);
+    LogMessage("Sessions Closing        :  " STDu64 "\n", sfBaseStats->curr_tcp_sessions_closing);
+    LogMessage("Max Cached Sessions     :  " STDu64 "\n", sfBaseStats->max_sessions);
+    LogMessage("Max Sessions (interval) :  " STDu64 "\n", sfBaseStats->max_tcp_sessions_interval);
 
     /* more instrumentation for stream4/frag2 */
-    LogMessage("Stream Flushes/Sec     :  %.3f\n", sfBaseStats->stream_flushes_per_second);
-    LogMessage("Stream Cache Faults/Sec:  " STDu64 "\n", sfBaseStats->stream_faults);
-    LogMessage("Stream Cache Timeouts  :  " STDu64 "\n", sfBaseStats->stream_timeouts);
-
-    LogMessage("Frag Creates()s/Sec    :  %.3f\n", sfBaseStats->frag_creates_per_second);
-    LogMessage("Frag Completes()s/Sec  :  %.3f\n", sfBaseStats->frag_completes_per_second);
-    LogMessage("Frag Inserts()s/Sec    :  %.3f\n", sfBaseStats->frag_inserts_per_second);
-    LogMessage("Frag Deletes/Sec       :  %.3f\n", sfBaseStats->frag_deletes_per_second);
-    LogMessage("Frag AutoFrees/Sec     :  %.3f\n", sfBaseStats->frag_autofrees_per_second);
-    LogMessage("Frag Flushes/Sec       :  %.3f\n", sfBaseStats->frag_flushes_per_second);
-
-    LogMessage("Current Cached Frags   :  " STDu64 "\n", sfBaseStats->current_frags);
-    LogMessage("Max Cached Frags       :  " STDu64 "\n", sfBaseStats->max_frags);
-    LogMessage("Frag Timeouts          :  " STDu64 "\n", sfBaseStats->frag_timeouts);
-    LogMessage("Frag Faults            :  " STDu64 "\n\n", sfBaseStats->frag_faults);
-
-    LogMessage("New Cached UDP Ssns/Sec:  %.3f\n", sfBaseStats->new_udp_sessions_per_second);
-    LogMessage("Cached UDP Ssns Del/Sec:  %.3f\n", sfBaseStats->deleted_udp_sessions_per_second);
-
-    LogMessage("Current Cached UDP Ssns:  " STDu64 "\n", sfBaseStats->total_udp_sessions);
-    LogMessage("Max Cached UDP Ssns    :  " STDu64 "\n\n", sfBaseStats->max_udp_sessions);
-
-#ifdef TARGET_BASED
-    LogMessage("Attribute Table Hosts  :  " STDu64 "\n", sfBaseStats->current_attribute_hosts);
-    LogMessage("Attribute Table Reloads:  " STDu64 "\n\n", sfBaseStats->attribute_table_reloads);
+    LogMessage("Stream Flushes/Sec      :  %.3f\n", sfBaseStats->stream_flushes_per_second);
+    LogMessage("Stream Cache Faults/Sec :  " STDu64 "\n", sfBaseStats->stream_faults);
+    LogMessage("Stream Cache Timeouts   :  " STDu64 "\n", sfBaseStats->stream_timeouts);
+
+    LogMessage("Frag Creates()s/Sec     :  %.3f\n", sfBaseStats->frag_creates_per_second);
+    LogMessage("Frag Completes()s/Sec   :  %.3f\n", sfBaseStats->frag_completes_per_second);
+    LogMessage("Frag Inserts()s/Sec     :  %.3f\n", sfBaseStats->frag_inserts_per_second);
+    LogMessage("Frag Deletes/Sec        :  %.3f\n", sfBaseStats->frag_deletes_per_second);
+    LogMessage("Frag AutoFrees/Sec      :  %.3f\n", sfBaseStats->frag_autofrees_per_second);
+    LogMessage("Frag Flushes/Sec        :  %.3f\n", sfBaseStats->frag_flushes_per_second);
+
+    LogMessage("Current Cached Frags    :  " STDu64 "\n", sfBaseStats->current_frags);
+    LogMessage("Max Cached Frags        :  " STDu64 "\n", sfBaseStats->max_frags);
+    LogMessage("Frag Timeouts           :  " STDu64 "\n", sfBaseStats->frag_timeouts);
+    LogMessage("Frag Faults             :  " STDu64 "\n\n", sfBaseStats->frag_faults);
+
+    LogMessage("New Cached UDP Ssns/Sec :  %.3f\n", sfBaseStats->new_udp_sessions_per_second);
+    LogMessage("Cached UDP Ssns Del/Sec :  %.3f\n", sfBaseStats->deleted_udp_sessions_per_second);
+
+    LogMessage("Current Cached UDP Ssns :  " STDu64 "\n", sfBaseStats->total_udp_sessions);
+    LogMessage("Max Cached UDP Ssns     :  " STDu64 "\n\n", sfBaseStats->max_udp_sessions);
+
+    LogMessage("New Cached SCTP Ssns/Sec:  %.3f\n", sfBaseStats->new_sctp_sessions_per_second);
+    LogMessage("Cached SCTP Ssns Del/Sec:  %.3f\n", sfBaseStats->deleted_sctp_sessions_per_second);
+
+    LogMessage("Current Cached SCTP Ssns:  " STDu64 "\n", sfBaseStats->total_sctp_sessions);
+    LogMessage("Max Cached SCTP Ssns    :  " STDu64 "\n\n", sfBaseStats->max_sctp_sessions);
+
+    #ifdef TARGET_BASED
+    LogMessage("Attribute Table Hosts   :  " STDu64 "\n", sfBaseStats->current_attribute_hosts);
+    LogMessage("Attribute Table Reloads :  " STDu64 "\n\n", sfBaseStats->attribute_table_reloads);
 #endif
 
 #ifdef NORMALIZER
diff --git a/src/preprocessors/perf-base.h b/src/preprocessors/perf-base.h
index e08b2cf..45e4709 100644
--- a/src/preprocessors/perf-base.h
+++ b/src/preprocessors/perf-base.h
@@ -143,6 +143,11 @@ typedef struct _SFBASE
     uint64_t   iDeletedUDPSessions;
     uint64_t   iMaxUDPSessions;
 
+    uint64_t   iTotalSCTPSessions;
+    uint64_t   iNewSCTPSessions;
+    uint64_t   iDeletedSCTPSessions;
+    uint64_t   iMaxSCTPSessions;
+
     uint64_t   iMaxSessionsInterval;
     uint64_t   iMidStreamSessions;
     uint64_t   iClosedSessions;
@@ -160,11 +165,15 @@ typedef struct _SFBASE
     uint64_t   total_blocked_mpls_packets;
     uint64_t   total_blocked_mpls_bytes;
 
-    /**TCP packets ignored due to port/service filtering.*/
+    /* TCP packets ignored due to port/service filtering. */
     uint64_t   total_tcp_filtered_packets;
-    /**UDP packets ignored due to port/service filtering.*/
+
+    /* UDP packets ignored due to port/service filtering. */
     uint64_t   total_udp_filtered_packets;
 
+    /* SCTP packets ignored due to port/service filtering. */
+    uint64_t   total_sctp_filtered_packets;
+
     uint64_t   frag3_mem_in_use;
     uint64_t   stream5_mem_in_use;
 }  SFBASE;
@@ -245,6 +254,11 @@ typedef struct _SFBASE_STATS {
     double   deleted_udp_sessions_per_second;
     double   new_udp_sessions_per_second;
 
+    uint64_t   total_sctp_sessions;
+    uint64_t   max_sctp_sessions;
+    double   deleted_sctp_sessions_per_second;
+    double   new_sctp_sessions_per_second;
+
     uint64_t   max_tcp_sessions_interval;
     uint64_t   curr_tcp_sessions_initializing;
     uint64_t   curr_tcp_sessions_established;
@@ -265,11 +279,15 @@ typedef struct _SFBASE_STATS {
     SYSTIMES mpls_mbits_per_sec;
     int      avg_bytes_per_mpls_packet;
 
-    /**TCP packets ignored due to port/service filtering.*/
+    /* TCP packets ignored due to port/service filtering. */
     uint64_t   total_tcp_filtered_packets;
-    /**UDP packets ignored due to port/service filtering.*/
+
+    /* UDP packets ignored due to port/service filtering. */
     uint64_t   total_udp_filtered_packets;
 
+    /* SCTP packets ignored due to port/service filtering. */
+    uint64_t   total_sctp_filtered_packets;
+
     uint64_t   frag3_mem_in_use;
     uint64_t   stream5_mem_in_use;
 }  SFBASE_STATS;
@@ -286,6 +304,8 @@ int CloseStreamSession(SFBASE *sfBase, char flags);
 int RemoveStreamSession(SFBASE *sfBase);
 int AddUDPSession(SFBASE *sfBase);
 int RemoveUDPSession(SFBASE *sfBase);
+int AddSCTPSession(SFBASE *sfBase);
+int RemoveSCTPSession(SFBASE *sfBase);
 
 void UpdateWireStats(SFBASE *sfBase, int len, int dropped, int injected);
 void UpdateMPLSStats(SFBASE *sfBase, int len, int dropped);
diff --git a/src/preprocessors/perf-flow.c b/src/preprocessors/perf-flow.c
index 84020c7..c475217 100644
--- a/src/preprocessors/perf-flow.c
+++ b/src/preprocessors/perf-flow.c
@@ -7,6 +7,8 @@
 ** Copyright (C) 2002-2013 Sourcefire, Inc.
 ** Marc Norton <mnorton () sourcefire com>
 ** Dan Roelker <droelker () sourcefire com>
+** Joshua Kinard <kumba12345 () gmail com>
+**
 **
 ** NOTES
 **   4.10.02 - Initial Checkin.  Norton
@@ -31,14 +33,16 @@
 ** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 **
 **  DESCRIPTION
-**    The following subroutines track eand analyze the traffic flow
+**    The following subroutines track and analyze the traffic flow
 **  statistics.
 **
 **   PacketLen vs Packet Count
 **   TCP-Port vs Packet Count
 **   UDP-Port vs Packet Count
+**   SCTP-Port vs Packet Count
 **   TCP High<->High Port Count
 **   UDP High<->High Port Count
+**   SCTP High<->High Port Count
 **
 **
 */
@@ -101,6 +105,8 @@ int InitFlowStats(SFFLOW *sfFlow)
         sfFlow->portTcpDst = (uint64_t*)SnortAlloc(sizeof(uint64_t) * SF_MAX_PORT);
         sfFlow->portUdpSrc = (uint64_t*)SnortAlloc(sizeof(uint64_t) * SF_MAX_PORT);
         sfFlow->portUdpDst = (uint64_t*)SnortAlloc(sizeof(uint64_t) * SF_MAX_PORT);
+        sfFlow->portSctpSrc = (uint64_t*)SnortAlloc(sizeof(uint64_t) * SF_MAX_PORT);
+        sfFlow->portSctpDst = (uint64_t*)SnortAlloc(sizeof(uint64_t) * SF_MAX_PORT);
         sfFlow->typeIcmp = (uint64_t *)SnortAlloc(sizeof(uint64_t) * 256);
 
         first = 0;
@@ -112,6 +118,8 @@ int InitFlowStats(SFFLOW *sfFlow)
         memset(sfFlow->portTcpDst, 0, sizeof(uint64_t) * SF_MAX_PORT);
         memset(sfFlow->portUdpSrc, 0, sizeof(uint64_t) * SF_MAX_PORT);
         memset(sfFlow->portUdpDst, 0, sizeof(uint64_t) * SF_MAX_PORT);
+        memset(sfFlow->portSctpSrc, 0, sizeof(uint64_t) * SF_MAX_PORT);
+        memset(sfFlow->portSctpDst, 0, sizeof(uint64_t) * SF_MAX_PORT);
         memset(sfFlow->typeIcmp, 0, sizeof(uint64_t) * 256);
     }
 
@@ -124,6 +132,9 @@ int InitFlowStats(SFFLOW *sfFlow)
     sfFlow->portUdpHigh=0;
     sfFlow->portUdpTotal=0;
 
+    sfFlow->portSctpHigh=0;
+    sfFlow->portSctpTotal=0;
+
     sfFlow->typeIcmpTotal = 0;
 
     return 0;
@@ -180,6 +191,18 @@ void FreeFlowStats(SFFLOW *sfFlow)
         sfFlow->portUdpDst = NULL;
     }
 
+    if (sfFlow->portSctpSrc != NULL)
+    {
+        free(sfFlow->portSctpSrc);
+        sfFlow->portSctpSrc = NULL;
+    }
+
+    if (sfFlow->portSctpDst != NULL)
+    {
+        free(sfFlow->portSctpDst);
+        sfFlow->portSctpDst = NULL;
+    }
+
     if (sfFlow->typeIcmp != NULL)
     {
         free(sfFlow->typeIcmp);
@@ -255,7 +278,7 @@ int UpdateTCPFlowStatsEx(SFFLOW *sfFlow, int sport, int dport, int len)
 int UpdateUDPFlowStats(SFFLOW *sfFlow, int sport, int dport, int len )
 {
     /*
-     * Track how much data on each port, and hihg<-> high port data
+     * Track how much data on each port, and high<->high port data
      */
     if( sport <  1024 && dport > 1023 ) //sfFlow->maxPortToTrack )
     {
@@ -294,6 +317,48 @@ int UpdateUDPFlowStatsEx(SFFLOW *sfFlow, int sport, int dport, int len )
     return UpdateUDPFlowStats( sfFlow, sport, dport, len );
 }
 
+int UpdateSCTPFlowStats(SFFLOW *sfFlow, int sport, int dport, int len )
+{
+    /*
+     * Track how much data on each port, and high<->high port data
+     */
+    if( sport <  1024 && dport > 1023 ) //sfFlow->maxPortToTrack )
+    {
+        sfFlow->portSctpSrc  [ sport ]+= len;
+    }
+    else if( dport < 1024 && sport > 1023 ) //sfFlow->maxPortToTrack )
+    {
+        sfFlow->portSctpDst  [ dport ]+= len;
+    }
+    else if( sport < 1023 && dport < 1023 )
+    {
+        sfFlow->portSctpSrc  [ sport ]+= len;
+        sfFlow->portSctpDst  [ dport ]+= len;
+    }
+    else if( sport > 1023 && dport > 1023 )
+    {
+        sfFlow->portSctpSrc  [ sport ]+= len;
+        sfFlow->portSctpDst  [ dport ]+= len;
+
+        sfFlow->portSctpHigh += len;
+    }
+
+    sfFlow->portSctpTotal += len;
+
+    return 0;
+}
+
+int UpdateSCTPFlowStatsEx(SFFLOW *sfFlow, int sport, int dport, int len )
+{
+    if(!(perfmon_config->perf_flags & SFPERF_FLOW))
+       return 1;
+
+    if (sfFlow == NULL)
+        return 1;
+
+    return UpdateSCTPFlowStats( sfFlow, sport, dport, len );
+}
+
 int UpdateICMPFlowStats(SFFLOW *sfFlow, int type, int len)
 {
     if(type < 256)
@@ -431,19 +496,22 @@ int ProcessFlowStats(SFFLOW *sfFlow)
     memset(&sfFlowStats, 0x00, sizeof(sfFlowStats));
 
     /*
-    **  Calculate the percentage of TCP, UDP and ICMP
+    **  Calculate the percentage of TCP, UDP, SCTP, and ICMP
     **  and other traffic that consisted in the stream.
     */
     sfFlowStats.trafficTCP = 100.0 * (double)(sfFlow->portTcpTotal) /
                  (double)(sfFlow->byteTotal);
     sfFlowStats.trafficUDP = 100.0 * (double)(sfFlow->portUdpTotal) /
                  (double)(sfFlow->byteTotal);
+    sfFlowStats.trafficSCTP = 100.0 * (double)(sfFlow->portSctpTotal) /
+                 (double)(sfFlow->byteTotal);
     sfFlowStats.trafficICMP = 100.0 * (double)(sfFlow->typeIcmpTotal) /
                  (double)(sfFlow->byteTotal);
     sfFlowStats.trafficOTHER = 100.0 *
                    (double)((double)sfFlow->byteTotal -
                    ((double)sfFlow->portTcpTotal +
                    (double)sfFlow->portUdpTotal +
+                   (double)sfFlow->portSctpTotal +
                    (double)sfFlow->typeIcmpTotal)) /
                    (double)sfFlow->byteTotal;
 
@@ -553,6 +621,47 @@ int ProcessFlowStats(SFFLOW *sfFlow)
     sfFlow->portUdpTotal=0;
 
     /*
+    **  Calculate SCTP port processing based on src, dst and
+    **  total distributions.
+    */
+    for (i = 0; i < perfmon_config->flow_max_port_to_track; i++)
+    {
+        tot = sfFlow->portSctpSrc[i]+sfFlow->portSctpDst[i];
+        if(!tot)
+        {
+            sfFlowStats.portflowSCTP.totperc[i] = 0;
+            continue;
+        }
+
+        totperc= 100.0 * tot / sfFlow->portSctpTotal;
+
+        if(totperc > .1)
+        {
+            srate =  100.0 * (double)(sfFlow->portSctpSrc[i]) / tot ;
+            drate =  100.0 * (double)(sfFlow->portSctpDst[i]) / tot ;
+
+            sfFlowStats.portflowSCTP.totperc[i]    = totperc;
+            sfFlowStats.portflowSCTP.sport_rate[i] = srate;
+            sfFlowStats.portflowSCTP.dport_rate[i] = drate;
+        }
+        else
+        {
+            sfFlowStats.portflowSCTP.totperc[i] = 0;
+        }
+
+        sfFlow->portSctpSrc[i] = sfFlow->portSctpDst[i] = 0;
+    }
+
+    sfFlowStats.portflowHighSCTP = 100.0 * sfFlow->portSctpHigh /
+                                  sfFlow->portSctpTotal;
+
+    /*
+    **  Reset counters for next go round
+    */
+    sfFlow->portSctpHigh=0;
+    sfFlow->portSctpTotal=0;
+
+    /*
     **  Calculate ICMP statistics
     */
     for(i=0;i<256;i++)
@@ -609,6 +718,7 @@ static int DisplayFlowStats(SFFLOW_STATS *sfFlowStats)
     LogMessage(    "--------------------------------------\n");
     LogMessage("TCP:   %.2f%%\n", sfFlowStats->trafficTCP);
     LogMessage("UDP:   %.2f%%\n", sfFlowStats->trafficUDP);
+    LogMessage("SCTP:  %.2f%%\n", sfFlowStats->trafficSCTP);
     LogMessage("ICMP:  %.2f%%\n", sfFlowStats->trafficICMP);
     LogMessage("OTHER: %.2f%%\n", sfFlowStats->trafficOTHER);
 
@@ -672,6 +782,28 @@ static int DisplayFlowStats(SFFLOW_STATS *sfFlowStats)
 
     LogMessage("\n");
     LogMessage("\n");
+    LogMessage("SCTP Port Flows\n");
+    LogMessage(    "--------------\n");
+    for(i=0;i<SF_MAX_PORT;i++)
+    {
+        if(sfFlowStats->portflowSCTP.totperc[i] &&
+           sfFlowStats->portflowSCTP.dport_rate[i]  )
+        {
+            LogMessage("Port[%d] %.2f%% of Total, Src: %6.2f%% Dst: %6.2f%%\n",
+                        i, sfFlowStats->portflowSCTP.totperc[i],
+                        sfFlowStats->portflowSCTP.sport_rate[i],
+                        sfFlowStats->portflowSCTP.dport_rate[i]);
+        }
+    }
+
+    if(sfFlowStats->portflowHighSCTP > .1)
+    {
+        LogMessage("Ports[High<->High]: %.2f%%\n",
+                sfFlowStats->portflowHighSCTP);
+    }
+
+    LogMessage("\n");
+    LogMessage("\n");
     LogMessage("ICMP Type Flows\n");
     LogMessage(    "---------------\n");
     for(i=0;i<256;i++)
@@ -706,9 +838,10 @@ static int DisplayFlowIPStats(SFFLOW *sfFlow)
             continue;
         sfip_raw_ntop(key->ipA.family, key->ipA.ip32, ipA, sizeof(ipA));
         sfip_raw_ntop(key->ipB.family, key->ipB.ip32, ipB, sizeof(ipB));
-        LogMessage("[%s <-> %s]: " STDu64 " bytes in " STDu64 " packets (%u, %u, %u)\n", ipA, ipB,
+        LogMessage("[%s <-> %s]: " STDu64 " bytes in " STDu64 " packets (%u, %u, %u, %u)\n", ipA, ipB,
                 stats->total_bytes, stats->total_packets, stats->stateChanges[SFS_STATE_TCP_ESTABLISHED],
-                stats->stateChanges[SFS_STATE_TCP_CLOSED], stats->stateChanges[SFS_STATE_UDP_CREATED]);
+                stats->stateChanges[SFS_STATE_TCP_CLOSED], stats->stateChanges[SFS_STATE_UDP_CREATED],
+                stats->stateChanges[SFS_STATE_SCTP_CREATED]);
         total += stats->total_packets;
     }
     LogMessage("Classified " STDu64 " packets.\n", total);
@@ -735,13 +868,15 @@ static int WriteFlowIPStats(SFFLOW *sfFlow, FILE *fp)
             continue;
         sfip_raw_ntop(key->ipA.family, key->ipA.ip32, ipA, sizeof(ipA));
         sfip_raw_ntop(key->ipB.family, key->ipB.ip32, ipB, sizeof(ipB));
-        fprintf(fp, "%s,%s," CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64
-                CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 "%u,%u,%u\n",
+        fprintf(fp, "%s,%s," CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64
+                CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 CSVu64 "%u,%u,%u\n",
                 ipA, ipB,
                 stats->trafficStats[SFS_TYPE_TCP].packets_AtoB, stats->trafficStats[SFS_TYPE_TCP].bytes_AtoB,
                 stats->trafficStats[SFS_TYPE_TCP].packets_BtoA, stats->trafficStats[SFS_TYPE_TCP].bytes_BtoA,
                 stats->trafficStats[SFS_TYPE_UDP].packets_AtoB, stats->trafficStats[SFS_TYPE_UDP].bytes_AtoB,
                 stats->trafficStats[SFS_TYPE_UDP].packets_BtoA, stats->trafficStats[SFS_TYPE_UDP].bytes_BtoA,
+                stats->trafficStats[SFS_TYPE_SCTP].packets_AtoB, stats->trafficStats[SFS_TYPE_SCTP].bytes_AtoB,
+                stats->trafficStats[SFS_TYPE_SCTP].packets_BtoA, stats->trafficStats[SFS_TYPE_SCTP].bytes_BtoA,
                 stats->trafficStats[SFS_TYPE_OTHER].packets_AtoB, stats->trafficStats[SFS_TYPE_OTHER].bytes_AtoB,
                 stats->trafficStats[SFS_TYPE_OTHER].packets_BtoA, stats->trafficStats[SFS_TYPE_OTHER].bytes_BtoA,
                 stats->stateChanges[SFS_STATE_TCP_ESTABLISHED], stats->stateChanges[SFS_STATE_TCP_CLOSED],
diff --git a/src/preprocessors/perf-flow.h b/src/preprocessors/perf-flow.h
index c7534ad..14f7d53 100644
--- a/src/preprocessors/perf-flow.h
+++ b/src/preprocessors/perf-flow.h
@@ -5,6 +5,7 @@
 ** Copyright (C) 2002-2013 Sourcefire, Inc.
 ** Marc Norton <mnorton () sourcefire com>
 ** Dan Roelker <droelker () sourcefire com>
+** Joshua Kinard <kumba12345 () gmail com>
 **
 **
 ** This program is free software; you can redistribute it and/or modify
@@ -38,15 +39,17 @@
 typedef enum {
     SFS_TYPE_TCP   = 0,
     SFS_TYPE_UDP   = 1,
-    SFS_TYPE_OTHER = 2,
-    SFS_TYPE_MAX   = 3
+    SFS_TYPE_SCTP  = 2,
+    SFS_TYPE_OTHER = 3,
+    SFS_TYPE_MAX   = 4
 } SFSType;
 
 typedef enum {
     SFS_STATE_TCP_ESTABLISHED = 0,
     SFS_STATE_TCP_CLOSED      = 1,
     SFS_STATE_UDP_CREATED     = 2,
-    SFS_STATE_MAX             = 3
+    SFS_STATE_SCTP_CREATED    = 3,
+    SFS_STATE_MAX             = 4
 } SFSState;
 
 typedef struct _portflow {
@@ -77,6 +80,8 @@ typedef struct _sfflow {
     uint64_t   *portTcpDst;
     uint64_t   *portUdpSrc;
     uint64_t   *portUdpDst;
+    uint64_t   *portSctpSrc;
+    uint64_t   *portSctpDst;
 
     uint64_t   *typeIcmp;
 
@@ -86,6 +91,9 @@ typedef struct _sfflow {
     uint64_t    portUdpHigh;
     uint64_t    portUdpTotal;
 
+    uint64_t    portSctpHigh;
+    uint64_t    portSctpTotal;
+
     uint64_t    typeIcmpTotal;
 
     SFXHASH     *ipMap;
@@ -97,6 +105,7 @@ typedef struct _sfflow_stats {
 
     double    trafficTCP;
     double    trafficUDP;
+    double    trafficSCTP;
     double    trafficICMP;
     double    trafficOTHER;
 
@@ -106,6 +115,9 @@ typedef struct _sfflow_stats {
     PORTFLOW  portflowUDP;
     double    portflowHighUDP;
 
+    PORTFLOW  portflowSCTP;
+    double    portflowHighSCTP;
+
     ICMPFLOW  flowICMP;
 
 
@@ -128,6 +140,7 @@ int ProcessFlowIPStats(SFFLOW *sfFlow, FILE *fh);
 */
 int UpdateUDPFlowStatsEx(SFFLOW *, int sport, int dport, int len);
 int UpdateTCPFlowStatsEx(SFFLOW *, int sport, int dport, int len);
+int UpdateSCTPFlowStatsEx(SFFLOW *, int sport, int dport, int len);
 int UpdateICMPFlowStatsEx(SFFLOW *, int type, int len);
 int UpdateFlowIPStats(SFFLOW *, snort_ip_p src_addr, snort_ip_p dst_addr, int len, SFSType type);
 int UpdateFlowIPState(SFFLOW *, snort_ip_p src_addr, snort_ip_p dst_addr, SFSState state);
